
// CollectVisitor.java
// Andrew Davison, ad@coe.psu.ac.th, May 2023


import java.util.*;

import org.apache.commons.collections4.sequence.*;


public class CollectVisitor<T> implements CommandVisitor<T>
{
  private ArrayList<String> cmds;

  public CollectVisitor()
  {  cmds = new ArrayList<>();   }

  public void visitInsertCommand(T object)
  {  cmds.add("insert \"" + object + "\"");  }

  public void visitKeepCommand(T object)
  {  cmds.add("keep \"" + object + "\"");   }

  public void visitDeleteCommand(T object)
  {  cmds.add("delete \"" + object + "\"");   }

  public ArrayList<String> getCmds()
  {  return cmds;  }

}  // end of CollectVisitor class